REM -------------------------------------------------------
REM                      EGA.INC
REM        EGA-Anpassung fuer den Sprite-Editor
REM -------------------------------------------------------

SUB bildschirm
  CLS: SCREEN %schirm
  CALL farben
  FOR i% = 4 TO 364 step 8
    LINE(i%, 4) - (i%, 319), 14
  NEXT i%
  FOR i% = 4 TO 319 step 7
    LINE(4, i%) - (364, i%), 14
  NEXT i%
  FOR i% = 39 TO 289 step 35
    LINE(365, i%) - (369, i%), 14
  NEXT i%
  FOR i% = 44 TO 344 step 40
    LINE(i%, 0) - (i%, 3), 14
  NEXT i%
  LINE (460, 26) - (512, 78), 14, B
  LINE (378, 94) - (636, 142), 14, B
  FOR i% = 0 TO 15
    LINE(382+i%*16,100)-(382+i%*16+9,120), i%, BF
  NEXT i%
  LOCATE 1, 54: PRINT "SPRITE - EDITOR"
  LOCATE 10,49: PRINT "A B C D E F G H I J K L M N O P"
  LOCATE 15,54: PRINT "<F1> LADEN"
  LOCATE 16,54: PRINT "<F2> SPEICHERN"
  LOCATE 17,54: PRINT "<F3> NORMALPALETTE"
  LOCATE 18,54: PRINT "<F4> FARBEN NDERN"
  LOCATE 19,54: PRINT "<F5> TAUSCHEN"
  LOCATE 20,54: PRINT "<F6> VERGRSSERN"
  LOCATE 21,54: PRINT "<F8> GROSSBILD"
  LOCATE 22,54: PRINT "<F9> NEU"
  LOCATE 23,54: PRINT "<F0> ENDE"
  CALL feld
END SUB

REM -------------------------------------------------------

SUB farben
  SHARED pal%()
  PALETTE USING pal%(0)
END SUB

REM -------------------------------------------------------

SUB pfeilan(ta)
  LOCATE 12, 49 + ta * 2: PRINT chr$(24);
END SUB

REM -------------------------------------------------------

SUB pfeilaus(ta)
  LOCATE 12, 49 + ta * 2: PRINT" ";
END SUB

REM -------------------------------------------------------

SUB farbe
  SHARED pal%()
  FOR i% = 0 TO 14
    pal%(i%) = i%
  NEXT i%
  pal%(15) = 35
END SUB

REM -------------------------------------------------------

SUB palwechsel
  SHARED pal%(), taste
  ta = 0: CALL pfeilan(ta)
  LOCATE 13,49: PRINT "<F9> Abbruch";
  DO
    CALL tastatur
    SELECT CASE taste
    CALL pfeilaus(ta)
    CASE 75
      DECR ta
      IF ta < 0 THEN ta = 15
    CASE 77
      INCR ta
      IF ta > 15 THEN ta = 0
    CASE 72
      INCR pal%(ta)
      IF pal%(ta) > 63 THEN pal%(ta) = 0
      palette ta, pal%(ta)
    CASE 80
      DECR pal%(ta)
      IF pal%(ta) < 0 THEN pal%(ta) = 63
      palette ta, pal%(ta)
    END SELECT
    CALL pfeilan(ta)
  LOOP UNTIL taste = 67
  CALL pfeilaus(ta)
  LOCATE 13,49: PRINT space$(12);
END SUB

REM -------------------------------------------------------

  %sprgr=9184: %fd=44: %xbr=8: %ybr=7: %schirm=9
  %po1=5: %po2=11: %po3=10: %po4=464: %po5=30
  %tabz=97: %bw=639: %bs=349: %tende=113
  %anf=5: %pix=4

DIM spr%(%sprgr), feld(%fd, %fd), cur%(14)
DIM pal%(15), f2(%fd, %fd), dateiname(9)
DIM daten%(9, %fd, %fd), p%(15)
FOR i% = 0 TO 14: READ cur%(i%): NEXT i%
DATA  8,7,-17790,31828,-17790,31828,-17790,_
      31828,-17790,31828,-17790,31828,-17790,_
      31828,0

  %true=-1: %false=0

SCREEN %schirm: COLOR 15: anfang = %true
CALL farbe

REM -------------------------------------------------------

