(* ------------------------------------------------------ *)
(*                 Aenderungen zu DC.PAS                  *)
(*          (C) 1988 by Mark Richter und TOOLBOX          *)
(* ------------------------------------------------------ *)

(* Zeile 27: *)
end_of_program, out_cycle : BOOLEAN;
inp_file, out_file        : TEXT;
esc                       : CHAR;

(* Zeile 28/29: *)
command                  : (cl,instr,regr,step,run,go,
                            tim,bpt,int,ldf,sav,other,
                            hlp,view,ends);

(* Zeile 177: *)
'G': command := go; 'L': command := ldf; 'S': command:=sav;

(* Hinter Zeile 222: *)
PROCEDURE save_file; FORWARD;

(* Zeile 230: *)
sav : save_file; bpt : breakpoint; int : interrupt;

(* Hinter Zeile 245: *)
PROCEDURE save_file;
VAR i  : INTEGER;
    arg: INTEGER;
    st : mnem_str;
BEGIN
  IF Pos('.', item[2]) = 0 THEN
    item[2] := Concat(item[2], '.DC');
  IF Open_Sav_File(item[2]) THEN BEGIN
    FOR i := 0 TO mem_size DO BEGIN
      Write(out_file, i:2, ' ');
      IF memory[i].nocommand = TRUE THEN BEGIN
        dasm(memory[i].speicherwort, arg);
        WriteLn(out_file, ' DEF', ' ', arg:3);
      END ELSE BEGIN
        disassemble(memory[i].speicherwort, st, arg);
        WriteLn(out_file, st:4, ' ', arg:3);
      END;
    END;
    Close(out_file);
  END ELSE error(illfil);
END;

(* ------------------------------------------------------ *)
(*            Aenderungen zu DCTURMS.PAS                  *)
(* ------------------------------------------------------ *)

(* Hinter Zeile 42: *)
FUNCTION Open_Sav_File(filename: lines): BOOLEAN;
BEGIN
  Assign(out_file, filename);
  (*$I-*) ReWrite(out_file); (*$I+*)
  Open_Sav_File := (IOResult = null);
END;

(* ------------------------------------------------------ *)
