/********************************************************/
/*                     KEYDRIVE.C                       */
/*        Funktionstabellengesteuertes Programm         */
/*           (C) 1988 M.Schlter & TOOLBOX              */
/********************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

void links(void)
{
  printf("links rum\n");
}

void rechts(void)
{
  printf("rechts rum\n");
}

void oben(void)
{
  printf("oben rum\n");
}

void unten(void)
{
  printf("unten rum\n");
}

void ende(void)
{
  exit(0); /* Ende und aus */
}

/* Typendefinition fr Funktionszeiger 'funkp' */
typedef void (* funkp)(void);
/* Funktionszeiger-Tabelle */
funkp funktionstabelle[128];

main()
{
  /* Funktionstabelle initialisiern */
  funktionstabelle[19] = links;   /* ^S */
  funktionstabelle[4]  = rechts;  /* ^D */
  funktionstabelle[5]  = oben;    /* ^E */
  funktionstabelle[24] = unten;   /* ^X */
  funktionstabelle[15] = ende;    /* ^Q */

  while(-1) { /* auf alle Ewigkeit Tastatur abfragen */
    funktionstabelle[ getch() ]();
  }
}


