(**********************************************************)
(*                                                        *)
(*             Filename UTILITY.DCL                       *)
(*                                                        *)
(*      TOOLBOX-Spezial III  Echtzeitverarbeitung         *)
(*                                                        *)
(*      (C) TOOLBOX und Thomas Lang 1988                  *)                                             *)
(*                                                        *)
(*   Dieses File enthlt die fr die Utilities not-       *)
(*   wendigen Deklarationen. Sie knnen auch von jeder    *)
(*   sonstigen Aufgabe benutzt werden, es ist aber darauf *)
(*   zu achten, da alle Variablen, die von den Utilities *)
(*   mehrfach bentigt werden, nicht verndert werden.    *)
(*   Die Verwendung von Konstanten und Typen ergibt       *)
(*   aber natrlich keinerlei Probleme.                   *)
(*                                                        *)
(**********************************************************)

Const
   MaxDWNiedrig=9999;         (* maximale Zahl fr DW *)
                              (* AnteilNiedrig *)

Type
   Register8086=Record        (* die Register des 8086 *)
                   Case Integer Of (* so nur in Turbo-Pas *)
                      1:      (* als 16 Bit Register *)
                         (AX,BX,CX,DX,BP,
                          SI,DI,DS,ES,Flags:Integer);
                      2:      (* als 8 Bit Register *)
                              (* wobei aber nicht alle *)
                              (* deklariert sind *)
                         (AL,AH,BL,BH,CL,CH,DL,DH:Byte);
                   End;       (* zu Record Register8086 *)

   FileName=String[80];       (* evtl. anpassen *)

   Str40=String[40];
   Str255=String[255];

                              (* Deklaration aller Pro- *)
                              (* zeduren und Funktionen *)
                              (* als sogenannte Forwards *)

Procedure PIncrDW(Var DW:DoppelWort); Forward;
Function DWinReal(DW:DoppelWort):Real; Forward;
Procedure RealinDW(R:Real;Var DW:DoppelWort); Forward;
Function TimeNow:REAL; Forward;
Procedure PutHoch(HochNr:Byte); Forward;
Procedure PutFifo(FifoNr:Byte;Param:Integer); Forward;
Procedure PutPerAbs(PerNr:Byte;AbsZeit:Real); Forward;
Procedure PutPerDelta(PerNr:Byte;DeltaZeit:Real); Forward;
Function FrageJN(S:Str255):Boolean; Forward;
Function FrageInteger(S:Str255;Von,Bis:Integer):Integer;
                                                  Forward;
