
(* -------------------------------------------- *)
(*                 GRIODEMO.PAS                 *)
(*     Demo zur Verwendung der Unit GrInOut     *)
(*         (C) 1989 F.Prattes & TOOLBOX         *)
(* -------------------------------------------- *)
PROGRAM GrInOutDemo;
USES
  Crt, Graph, GrInOut;
VAR
  fontno :INTEGER;
  s : STRING;
  zahl : REAL;

PROCEDURE Wait;
VAR
  c:CHAR;
BEGIN
  WHILE  KeyPressed DO c := ReadKey;
  REPEAT UNTIL KeyPressed;
  c := ReadKey;
  ClearDevice
END; (* Wait *)

PROCEDURE Intro;
VAR
  i, vgr : INTEGER;

BEGIN
  i := 0;
  REPEAT
    IF i = SmallFont THEN
      vgr := 5
    ELSE
      vgr := 1;
    SetTextStyle(i, HorizDir, vgr);
    GotoXY(1,1);
    Write('GrInOut-Unit, eine Unit zur');
    WriteLn(' Textausgabe im Graphikmodus');
    WriteLn;
    Write('Dieser Text wird mit normalen Write');
    Write('-Befehlen ausgegeben. Egal, welche ');
    Write('Schriftart Sie waehlen, die Ausgabe');
    Write('routinen in der GrInOut-Unit passen');
    WriteLn(' sich an.');
    WriteLn;
    Write('Mit GotoXY koennen Sie die Position');
    Write(' der Ausgabe bestimmen, ');
    Write('und mit ClrEol bis zum Zeilenende ');
    WriteLn('loeschen.');
    WriteLn;
    Write('Bitte eine Taste druecken...');
    Wait;
    Inc(i)
  UNTIL (i > 4);
END; (* Intro *)

PROCEDURE WriteAbc;
VAR
  c : CHAR;
BEGIN
  GotoXY(1,1);
  FOR c:='A' TO 'Z' DO Write(c)
END; (* WriteAbc *)

PROCEDURE WriteLines;
VAR
  i : INTEGER;
BEGIN
  GotoXY(1,1);
  Write('MaxPosY: ',GetMaxPosY);
  GotoXY(1,2);
  FOR i:=2 TO GetMaxPosY DO
    WriteLn(i:2,' .Zeile')
END; (* WriteLines *)

BEGIN
  InitGraphic;
  Intro;
  FOR fontno := 0 TO 2 DO BEGIN
    SetTextStyle(fontno, HorizDir, fontno*2 + 1);
    WriteAbc;
    Wait;
    WriteLines;
    Wait;
  END;
  SetTextStyle(TriplexFont, HorizDir, 2);
  GotoXY(1,1);
  Write('Ihre Eingabe bitte (String): ');
  ReadLn(s);
  WriteLn('Echo: ',s);
  Write('Ihre Eingabe bitte (Zahl)  : ');
  ReadLn(zahl);
  WriteLn('Echo: ',zahl:10:2);

  Write('Bitte eine Taste druecken...');
  Wait;
  LeaveGraphic
END. (* GrInOutDemo *)
