(* ------------------------------------------------------ *)
(*                      TEST7.PAS                         *)
(*               Zeichnen in RAM-Bildschirm               *)
(*           (c) 1989 Peter Bierbach & TOOLBOX            *)
(* ------------------------------------------------------ *)
PROGRAM Test7;

{$I GRAPH.P  }
           { Grafik-Befehle fr CGA-Schirm --> GRAPH.BIN }
{$i R7GRAPH.NEU }
           { Grafik-Befehle fr RAM-Schirm --> R7GRAPH.RAM }

(* Wenn Sie einen Monochrom-Bildschirm haben, dann ndern *)
(* Sie bitte "GraphColorMode" in "GraphMode" um.          *)

VAR
  bildcga : ARRAY[1..16000] OF BYTE ABSOLUTE $b800:0;
  bildram : ARRAY[1..16000] OF BYTE ABSOLUTE $7800:0;
  bild    : ARRAY[1..2000]  OF BYTE;
  z       : INTEGER;

BEGIN
  GraphColorMode;       { 3.0 Grafik-Befehl auf CGA-Schirm }
  r7graphmode;          { 3.0 Grafik-Befehl auf RAM-Schirm }
  ClearScreen;          { 3.0 Grafik-Befehl auf CGA-Schirm }
  r7clearscreen;        { 3.0 Grafik-Befehl auf RAM-Schirm }

                   { 80 Kreise auf CGA-Schirm --> sichtbar }
  WriteLn('Jetzt wird im CGA-Schirm gezeichnet...');
  FOR z := 1 TO 80 DO Circle(100, 100, z, 1);
  WriteLn;
  WriteLn('jetzt wird im RAM-Schirm gezeichnet...');
    { 80 Kreise auf RAM-Schirm ab $7800 --> nicht sichtbar }
  FOR z:=1 TO 80 DO r7circle (200, 100, z, 3);
  Move(bildram, bildcga, 16000);
  WriteLn('RAM-SCHIRM nach CGA-SCHIRM kopiert !');
  Delay(3000);
  ClearScreen;
  WriteLn('Ein Trick mit GET und PIC: ');

  FOR z:=50 TO 280 DO BEGIN
    r7getpic(bild, 10 + z, 130, 60 + z, 180);
                 { Bildausschnitt aus dem RAM-Schirm holen }
    PutPic(bild, 100, 100); { und in den CGA-Schirm setzen }
  END;
END.
(* ------------------------------------------------------ *)
(*                   Ende von TEST7.PAS                   *)
