/* ------------------------------------------------------ */
/*                     OUTCMOS.C                          */
/*          Auslesen des CMOS-RAMs von ATs                */
/*         (c) 1989  Jens Krger & TOOLBOX                */
/* ------------------------------------------------------ */
#include <stdio.h>
#include <dos.h>                   /* fr Port-Funktionen */

main()
{
 unsigned char loop = 0;           /* Schleifenzhler     */
 unsigned char b1, b2;             /* Zwischenspeicher    */

 while (loop <= 0x35)
  {
   outportb(0x70, loop++);   /* Adressieren des Registers */
   b1 = inportb(0x71);       /* Auslesen der Daten        */
                             /* zum Schreiben:            */
                             /* outportb(0x71, b1)        */
   outportb(0x70, loop++);
   b2 = inportb(0x71);
   printf("\n %02X   %02X  ", (loop-2), b1);
   printf("  |    %02X   %02X", (loop-1), b2);
  }
}
/* ------------------------------------------------------ */
/*                 Ende von OUTCMOS.C                     */
