(*********************************************************)
(*                     TESTFSEL.MOD                      *)
(*   Testprogramm zur Dateiauswahlbox fr TopSpeed M2    *)
(*            (C) 1989 Dirk Donath & TOOLBOX             *)
(*********************************************************)

MODULE TestFSelect;

IMPORT IO, FSelect;

VAR
  Frage     : FSelect.FraTyp;
  Antwort   : FSelect.AntTyp;
  Dateiname : ARRAY[0..80] OF CHAR;

BEGIN
  (* Patternfenster definieren *)
  WITH Frage DO
    X1     := 2;
    Y1     := 2;
    Breite := 40;
    Prompt := 'Datei(maske):';
  END;
  (* Dateifenster definieren *)
  WITH Antwort DO
    X1      := 5;
    Y1      := 5;
    Zeilen  := 5;
    Spalten := 3;
  END;
  IF FSelect.GetFName(Frage,Antwort,Dateiname) THEN
    IO.WrStr(Dateiname); IO.WrStr(' gewhlt.');
  ELSE
    IO.WrStr('Kein Dateiname gewhlt.');
  END;
  IO.WrLn;
END TestFSel.

