1 '****************************************************************************
2 '
3 '  Hanoi_HK.BAS      :Nicht-rekursiver ( iterativer ) Algorithmus, der zeigt,   '  wie die Umsetzung  des   TURMs VON HANOI   der Erzeugung eines  einschrit-   '  tigen, binren und zyklischen  Codes quivalent  ist.(C) W.D.Meisel, 1986.   '
4 '  Eine  Arbeit ber  die Struktur und Erzeugung derartiger Algorithmen wird    '  an anderer Stelle  verffentlicht werden.                                    '
5 '  Hierarchisches Programm  in    WHILE-BASIC ( ohne GOTO  und GOSUB nur mit    '  Zielzeile 100  -- (mit zwei,   die Iteration zeitoptimierenden Ausnahmen).   '  Die Ausgaben sind  zustzlich  durch Umstellen beschleunigt.                 '
6 '  Verschiedene Tips  und Tricks  sind im Quelltext knapp dokumentiert.  U.a.   '  finden Sie Verfahren zum Abbruch auch beim EXE-File, fr "standfeste" Ein-   '  gaben, zur BOOLE-Algebra bei BASIC, zur  Kombination von Bewegungsablufen   '  usw.
7 '
8 '****************************************************************************   '                                                                               '
9                                                         '=========='
10   WHILE NOT          PROGRAMM%  :PROGRAMM%  =-1        'Einleitung'
11   KEY   OFF         :WIDTH 80   :CLS                   '=========='
12   DEFINT   A - Z    :TRUE= -1   :FALSE= 0   :DEF   SEG                                              'Besitzt 'ne INTEGER-Variable  x%  =-1  als Wert, so ist                        'while x%   "wahr" und   fr   x%  = 0 "falsch"
13   KEY 17,  CHR$(4)  +CHR$(70)   'Key 11 - 14 sind  von  BASIC definiert !!!!
15   IF NOT   K12       THEN        K12=TRUE   :ON KEY(12) GOSUB  15                                    ELSE        LINKSPFEIL =TRUE      :GOSUB 100:    RETURN
16   IF NOT   K13       THEN        K13=TRUE   :ON KEY(13) GOSUB  16                                    ELSE        RECHTSPFEIL=TRUE      :GOSUB 100:    RETURN
17   IF NOT   K17       THEN        K17=TRUE   :ON KEY(17) GOSUB  17                                    ELSE        ABBRUCH    =TRUE
18   IF    ABBRUCH      THEN Z$  = "Abbruch des Programms  durch Benutzer !"    :       IF A.NR =2      THEN CLS   :END         ELSE LOCATE 21,1 :PRINT Z$ :END :          LOCATE 21, 1:PRINT       SPACE$(40) :PRINT"  " :PRINT"     ";:RETURN
19         ERSTMALS    =TRUE
20   WEND 'Vorbereitung:Programm% als implizite  Definition ist notwendig, weil      '     noch   keine explizite Definition erfolgt ist  - wie z.B. DEFINT A-Z      '
21   '     KEY 17 weist dem  CTRL+BREAK nach    KEY(17) ON eine neue Rolle zu :      '     Das Programm wird sofort beendet  -- Mit   CONT kann bei  GW - BASIC      '     nach END fortgesetzt werden !!!!,    im compilierten Programm  nicht      '
99   '                                                                               '-------------------------------------------------------------------------      '
100  :                 'Unterprogramm-Sprnge erfolgen (fast) immer auf   100 !                        'Ausgefhrt wird dann der durch <Name> =TRUE aktivierte                         'WHILE..WEND-Block und dort Desaktivierung sowie RETURN
109  '                                                                               '-------------------------------------------------------------------------      '
110  WHILE PROGRAMM    :PROGRAMM                                         =FALSE
111  IF    ERSTMALS     THEN        A.EIN= 1 :T.EIN= 3 :S.EIN$="A":Z.EIN$=  "C" :                       DL   =256           ' Setzen von  Parametervorschlgen                                              ' dl steuert Bildausgabeverzgerung
112                                 LOCATE ,, 1
113    MENUE    =TRUE  :GOSUB 100  :LOCATE ,, 0
114    HANOI    =TRUE  :GOSUB 100  :LOCATE ,, 1
115    ABSCHLUSS=TRUE  :GOSUB 100
116  WEND 'Programm    :Die 3 Aufrufe MENUE, HANOI und ABSCHLUSS beinhalten die      '                  g e s a m t e Programmsteuerung                              '
119  '                                                                               '----------------- Nun folgen Hilfsprogramme zur Cursorsteuerung ---------      '
150  WHILE LINKSPFEIL  :LINKSPFEIL =FALSE    :Z.ALT=CSRLIN:S.ALT=POS(0)
151  IF DL>1 THEN  DL  =DL\2 :DY   =DL+(DL=1)'schneller, da  weniger  verzgert
152  LOCATE 25,71      -(A.NR=2)   :PRINT DY;:LOCATE Z.ALT,S.ALT
153  RETURN
154  WEND
155  WHILE RECHTSPFEIL :RECHTSPFEIL=FALSE    :Z.ALT=CSRLIN:S.ALT=POS(0)
156  IF DL<16384        THEN  DL   =DL*2     'langsamer, da  m e h r  verzgert
157  LOCATE 25,71      -(A.NR=2)   :PRINT DL;:LOCATE Z.ALT,S.ALT
158  RETURN
159  WEND              'Geschwindigkeitssteuerung durch  Tasten                      '
160  '                  BOOLE'sche Algebra in BASIC mit INTEGER-Funktionen:          '                  (Z=X) ist  -1, falls "wahr" sonst  0    und ebenso           '                  (Z)   ist  -1, falls  Z<>0  sonst  0    usw.
161  '                  Ausserdem  ist NOT Z% als  -1-Z% zu berechnen, was           '                  fr "wahr" die Festlegung Z%=-1  erfordert !!!!!!!           '
199  '                                                                               '----------------- Nun folgt   die Menue-Maske ---------------------------      '
200  WHILE MENUE       :MENUE                                            =FALSE
201    CLS
202    PRINT"              E i n g a b e n ,  um den TURM VON HANOI umzusetzen.
203    PRINT
204    PRINT" Das Programm schlgt Ihnen ein MENUE vor. Wenn Sie daran etwas" ;
205    PRINT" ndern  wollen,"     :PRINT" geben Sie bitte"                   ;
206    PRINT" den Anfangsbuchstaben des betroffenen Parameters und die dafr
207    PRINT" zulssigen Werte ein (  z.B.   T=7   oder P:C,B  ).
208    LOCATE  8, 7    :COLOR 15,0 :PRINT"A";:COLOR 7,0:PRINT"usgabeformen   ";
209                     COLOR 15,0 :PRINT"1";:COLOR 7,0
210                                 PRINT"  T e x t g r a f i k
211    LOCATE  9,23    :COLOR 15,0 :PRINT"2";:COLOR 7,0
212                                 PRINT"  Liste => Bildschirm
213    LOCATE 10,23    :COLOR 15,0 :PRINT"3";:COLOR 7,0
214                                 PRINT"  Liste =>    Drucker
215    LOCATE 11,23    :COLOR 15,0 :PRINT"4";:COLOR 7,0
216                                 PRINT"  kombiniert `1'und`3'
217    LOCATE 13, 7    :COLOR 15,0 :PRINT"T";:COLOR 7,0:PRINT"urmhhe        ";
218                                 PRINT"zwischen       "                    ;
219                     COLOR 15,0 :PRINT"1";:COLOR 7,0:PRINT" und "          ;
220                     COLOR 15,0 :PRINT"9"
221    LOCATE 16, 7    :COLOR 15,0 :PRINT"P";:COLOR 7,0:PRINT"ltze          ";
222                                 PRINT"Start,Ziel   { "                   ;
223                     COLOR 15,0 :PRINT"A,B,C"      ;:COLOR 7,0   :PRINT  " }
224    LOCATE  8,57                :PRINT"Vorschlag A ="       ;          A.EIN
225    LOCATE  9,57                :PRINT"Ihre Wahl ?  "
226    LOCATE 13,57                :PRINT"Vorschlag T ="       ;          T.EIN
227    LOCATE 14,57                :PRINT"Ihre Wahl ?  "
228    LOCATE 16,57                :PRINT"Vorschlag P : "      ;S.EIN$","Z.EIN$
229    LOCATE 17,57                :PRINT"Ihre Wahl ?  "
230    LOCATE 20, 7                :PRINT"Mit der Eingabe "                   ;
231                     COLOR 15,0 :PRINT"E";:COLOR 7,0:PRINT"nde wird der V" ;
232                                 PRINT"orschlag   durch   Ihre Wahl ergnzt.
233    LOCATE 22, 2                :PRINT"Bitte whlen Sie .. :"              ;
234    LOCATE 22,49                :PRINT"und drcken Sie die Taste ENTER
235    AUSWAHL=TRUE    :A.MAX  = 4                        :     GOSUB       100 :                                                                        RETURN
239  WEND 'Menue  ruft  jeweils     Auswahl samt anschlieender Auswertung  auf      '     End.Auswahl  setzt dann  die restlichen Programmparameter   und ruft      '     den zweiten  Hauptteil   HANOI  im    PROGRAMM                            '
250  WHILE END.AUSWAHL :END.AUSWAHL  =  FALSE  : UNZULAESSIG             =FALSE
251    IF  ERSTMALS     THEN    DIM   HOEHE%(2), FUNDAMENT%(9)  ,WEGWEISER% (9)                        ,HOCH%(2)     ,PLATZ$(2), DREHUNG%(1)    ,ZEILE$(18)
252        N     =T.EIN:START$       =  S.EIN$ : ZIEL$    =      Z.EIN$
253        A.NR  =A.EIN:START  =ASC(START$)-65 : ZIEL     =  ASC(ZIEL$)  -   65
255    FOR J=0 TO 2    :HOEHE%   (J) =0:NEXT   : HOEHE%         (START)  =    N
256                     ECHTZEIT.LFD!=0
257        KEY (12) ON :KEY (13) ON  :KEY (17)   ON
258        DEF SEG = 0 :POKE 1050   ,PEEK(1052): DEF SEG  :              RETURN           'Tastaturpuffer jetzt leer :vergleiche hierzu die  Zeilen 5018 - 5019
259  WEND 'End.Auswahl  und Anpassung an Ausgabe und Algorithmus                     '     Dim Platz$   hier (statt in 6000 ff.) fr konsekutive Compilation !!      '
299  '                                                                               '----------------- Nun folgt  der nichtrekursive Algorithmus -------------      '                  zum Umsetzen des  Turm's von  HANOI                          '
300  WHILE HANOI       :HANOI                                            =FALSE
310        STOCKWERK=9 :ANFANG   = 3-ZIEL+START: MITTE    = 3 - ZIEL   -  START :          DREHUNG%(1) =ANFANG   *(1     +N MOD  2)                             :          DREHUNG%(0) =ANFANG   *(2     -N MOD  2)'abhngig v. Ziel,Start u. N
320    FOR J=1 TO N    :FUNDAMENT%(J)    =START: WEGWEISER%(J)= 1        : NEXT
330                     BESCHRIFTUNG           = TRUE     :     GOSUB 100
335                    'Abwechselnd werden immer das ursprnglich N -te  Stock-                        'werk und dann  dasjenige umgesetzt, dessen bergeordne-                        'tes eine gerade Zahl von Umsetzungen hinter sich hat.
340                     ECHTZEIT!              = TIMER
350    FOR SCHRITT  =1  TO   2^N - 1
351    IF  STOCKWERK>1  THEN       STOCKWERK=1 : ELSE           STOCKWERK=    2 :          WHILE        WEGWEISER%(STOCKWERK-1)> 0                              :                       STOCKWERK= STOCKWERK+1 :                           WEND
352        DREHUNG     =DREHUNG%  (STOCKWERK     MOD 2)
353        VON         =FUNDAMENT%(STOCKWERK)  : NACH     =(VON+DREHUNG)MOD   3
354                     FUNDAMENT%(STOCKWERK)  = NACH
355                     WEGWEISER%(STOCKWERK)  =-WEGWEISER%    (STOCKWERK)
356                     AUSGABE                = TRUE     :     GOSUB       900
357    NEXT
360                     ECHTZEIT!              = TIMER    -     ECHTZEIT!
370                     END.AUSGABE            = TRUE     :     GOSUB 100
380                                                                      RETURN
389  WEND 'Hanoi        Zeit-Optimierung mit     GOSUB 900  in  Zeile 356            '                  Die Wegweiser ergeben den in Zeile  3   erwhnten            '                  einschrittigen, binren  zyklischen Code !!!!!!!!
399  '                                                                               '----------------- Das Ausgabeende fhrt zurck nach PROGRAMM ------------      '                  und dort in den 3.Hauptabschnitt ABSCHLUSS                   '
400  WHILE ABSCHLUSS   :ABSCHLUSS                                        =FALSE
401        KEY (12)OFF :KEY (13)  OFF:KEY (17)OFF  :ERSTMALS             =FALSE
402     IF A.NR=3       THEN      LOCATE 4,1
403  PRINT"Noch ein Durchlauf erwnscht ( J/N ) "; :COLOR 23:PRINT "?"        ; :          ZLPOS       =CSRLIN   :SPOS  =POS(0)    :COLOR  7                    :          WUNSCH  = 1
404  WHILE WUNSCH <= 1 :WUNSCH$  =INKEY$:WUNSCH    =INSTR("#NnJj",WUNSCH$):WEND           'Beachte:Mit  Wunsch$  ="" ist Wunsch    =1,also # eingefgt !!
405     IF WUNSCH  > 3  THEN      PROGRAMM=TRUE    :JA      =TRUE                                       ELSE IF   WUNSCH>1    THEN  JA      =FALSE
406     IF NOT JA THEN  LOCATE    ZLPOS,SPOS-1     :PRINT  ": NEIN ----> Ende"; :          IF   A.NR=2  OR A.NR=3                                                                 THEN  LOCATE    ZLPOS-3   ,1      ELSE     LOCATE      1,1
407                     LFD.     =FALSE                     :            RETURN
409  WEND 'Abschluss   (lfd. vereinfacht  die Ausgabeform    A.Nr.4 (s.4000ff.)      '                                                                               '
499  '*************************************************************************      '----------------- Nun folgt die  E I N G A B E  der Parameter -----------      '                  und deren Prfung auf Zulssigkeit lt.MENUE                  '
500  WHILE AUSWAHL   :     AUSWAHL                                      =FALSE
501     OK=  FALSE   :     EINGABE             = TRUE       :GOSUB 100
502       ZEICHEN$   =     LEFT$(EINGABE$,1)
503    IF ZEICHEN$   > "`" THEN  ZEICHEN$      = CHR$(ASC(ZEICHEN$)-32)
504    IF ZEICHEN$ < > "E" THEN  LOCATE 22,23  : PRINT SPACE$(21)               :                                LOCATE 23, 1  : PRINT SPACE$(79)
505    IF ZEICHEN$   = "A" THEN AUSGABEFORM=     TRUE       :OK =  TRUE
506    IF ZEICHEN$   = "T" THEN TURMHOEHE  =     TRUE       :OK =  TRUE
507    IF ZEICHEN$   = "P" THEN PLAETZE    =     TRUE       :OK =  TRUE
508    IF ZEICHEN$   = "E" THEN END.AUSWAHL=     TRUE       :GOSUB 100 : RETURN
509    IF  NOT OK          THEN UNZULAESSIG=     TRUE                                                      ELSE UNZULAESSIG=     FALSE
510    GOSUB 100     :     AUSWAHL                                     = TRUE
519  WEND 'Auswahl         End.Auswahl  fhrt zu PROGRAMM,   nachdem                 '                     die Parameter notiert worden sind                         '
600  WHILE EINGABE        :E$="" :Z= 0 :ZZ =-1 : EINGABE$="":LOCATE      22, 23
601   WHILE  ZZ
602    WHILE E$=""        :E$=INKEY$   :IF      (E$ ="E" OR E$="e")  AND Z  = 0                                         THEN     E  =-1 ELSE E= 0
603       IF E   THEN      EINGABE = 0 :LOCATE   22 ,49     :PRINT   SPACE$(31) :         LOCATE 22,23    :COLOR 0 , 7 :PRINT   "Eingabeende"                 ; :                          COLOR 7 , 0 :         EINGABE$="E"           :RETURN
604    WEND :E.=-ASC(E$) *(LEN(E$) = 1)        : IF E.= 8    THEN  IF     Z > 0        THEN  Z = Z - 1    :OL      =    CSRLIN : OS=POS(0)   : LOCATE  OL,OS -1 :      PRINT" ";:EINGABE$= LEFT$(EINGABE$,  LEN (EINGABE$)-1): LOCATE  OL,OS -1
605       IF 32< E. AND E.<127                   THEN                                     IF Z < 5         THEN  EINGABE$  =     EINGABE$+E$:PRINT E$;   :Z=Z+1                            ELSE  BEEP
606          E$=""        :IF    E.=13           THEN                                     IF Z > 0         THEN  PRINT CHR$(13): ZZ= 0      :EINGABE     =FALSE                            ELSE  BEEP
607   WEND'Vor Compilation bitte in 603          For hz= 0   to  7000 :   next:           'vor color 7,0   einfgen, um das Eingabeende etwas lnger anzuzeigen
608                                                                      RETURN
609  WEND 'Eingabe         zeichenweise   und    zwischenraumfrei                    '     mit             Steuerung     durch   backspace und  carriage-return      '    (LEN(E$) = 1)    hat den Wert  -1,     falls WAHR, sonst 0                 '
610  WHILE UNZULAESSIG    :UNZULAESSIG     =     FALSE
611    LOCATE 22,23       :PRINT SPACE$(21);
612    LOCATE 23, 2       :PRINT"U N Z U L  S S I G !! - Bitte neue Eingabe  " ; :    PRINT"  statt   "; :COLOR 0,7           : PRINT" "EINGABE$" ";:COLOR 7,0
613                                                                      RETURN
619  WEND 'Unzulssig                                                                '
700  WHILE AUSGABEFORM    :AUSGABEFORM     =     FALSE 'liefert A aus (1,2,3,4)
701        A              =VAL (MID$(EINGABE$,3))
702  IF  A<1 OR  A>A.MAX   THEN UNZULAESSIG=     TRUE       :GOSUB 100 : RETURN
703  IF  0<A AND A<A.MAX+1 THEN LOCATE  9,67   : PRINT"A =" ;A         :A.EIN=A
704                                                                      RETURN
709  WEND 'Ausgabeform                                                               '
710  WHILE TURMHOEHE      :TURMHOEHE       =     FALSE 'liefert      0 < T < 10
711        T              =VAL (MID$(EINGABE$,3))
712    IF  T<1 OR  T>9     THEN UNZULAESSIG=     TRUE       :GOSUB 100 : RETURN                            ELSE LOCATE 14,67   : PRINT"T =" ;T         :T.EIN=T
713                                                                      RETURN
719  WEND 'Turmhoehe                                                                 '
720  WHILE PLAETZE        :PLAETZE         =     FALSE 'liefert s$<>z$ (A,B,C)
721        P$             =     MID$(EINGABE$,3)
722    IF  LEN(P$) <>3     THEN UNZULAESSIG=     TRUE       :GOSUB 100 : RETURN
723        S$             =LEFT$ (P$,1):IF S$>"`"THEN S$    =CHR$ (ASC(S$) -32)
724        Z$             =RIGHT$(P$,1):IF Z$>"`"THEN Z$    =CHR$ (ASC(Z$) -32)
725        IF   S$ = Z$    OR   S$<"A"  OR S$>"C"  OR Z$<"A" OR        Z$> "C"                             THEN UNZULAESSIG=     TRUE       :GOSUB 100 : RETURN                            ELSE LOCATE 17,67   : PRINT   "P : "        S$"," Z$
726                                              S.EIN$ =S$ :Z.EIN$        = Z$
727                                                                      RETURN
729  WEND 'Plaetze                                                                   '                                                                               '
899  '*************************************************************************      '---- Ab hier beginnt die Zusammenstellung der A U S G A B E N -----------      '     aufgeteilt in AUSGABE A(uswahl).Nr und BESCHRIFTUNG A.Nr                  '
900  WHILE AUSGABE AND     NOT A.NR.ABHAENGIG  : A.NR.ABHAENGIG          = TRUE
901                        ECHTZEIT.LFD!       = TIMER    -     ECHTZEIT.LFD!
902        SCHRITT$       =STR$     (SCHRITT)                                   :          VON$           =CHR$     (VON +65)  : NACH$         =CHR$  (NACH+65)
903                                                             GOSUB  1000
904        HOEHE%(VON)    =HOEHE%   (VON)-1    : HOEHE%(NACH)  =HOEHE%(NACH)+1
905                        ECHTZEIT.LFD!       = TIMER    -     ECHTZEIT.LFD!
906                                              A.NR.ABHAENGIG          =FALSE
907                                                                      RETURN
909  WEND 'gemeinsame      Ausgabe             ( z.B. Zeitmessung fr Ausgaben)      '                     Zeit-Optimierung   mit     GOSUB 1000 in  Zeile 903       '
999  '-------------------------------------------------------------------------      '     Ausgabe 1  zeigt ein textgrafisches   Umsetzen des   Turm's               '-------------------------------------------------------------------------      '
1000 WHILE AUSGABE         AND A.NR=1          : AUSGABE                 =FALSE
1001   FOR J=12 TO 17                          ' *************  Schiebefenster
1002                                             ZEILE$(J-1)   =ZEILE$(J)
1003   LOCATE         J -1,66                  : PRINT          ZEILE$(J-1)
1004   NEXT
1005   STOCKWERK0   = STOCKWERK                                                 :      STOCKWERK1   = STOCKWERK+INV            *(N+1 -STOCKWERK-STOCKWERK)
1006   ZEILE$(17)   = SCHRITT$                 + SPACE$  (5-LEN(SCHRITT$))                          + STR$(STOCKWERK1)         + "   "   +VON$+"  "+NACH$
1007   LOCATE 17,66 : COLOR 31,0               : PRINT ZEILE$(17)  :COLOR   7,0
1010   '**************************************** Optimierung der berflughhe !
1011   IF HOEHE%(0) <=HOEHE%(1) AND HOEHE%(2)<=HOEHE%(1) AND VON<>1 AND NACH<>1        THEN UEBERFLUG=HOEHE%(1)+1   ELSE    IF HOEHE%(NACH)     <   HOEHE%(VON)        THEN UEBERFLUG=HOEHE%(VON)   ELSE       UEBERFLUG=HOEHE%(NACH)+1         '
1021                  SP.NR=1+22*VON      : Z.NR=18-HOEHE%(VON)   'aufwrts ***
1022   WHILE  Z.NR  > 18   -UEBERFLUG
1023   LOCATE Z.NR  , SP.NR:PRINT ZEILE$(0)
1024   LOCATE Z.NR-1, SP.NR:PRINT ZEILE$(STOCKWERK1)           :Z.NR  =  Z.NR-1
1025   WEND                                                                     '
1031          BETRAG= ABS(NACH-VON)*22    : VZ = SGN(NACH-VON) 'seitwrts *****
1032                                        SP.ANF= 9+22 *VON-( STOCKWERK0)* VZ :                                           SP.END=10+22 *VON+( STOCKWERK0)* VZ
1033   FOR J= 1 TO    BETRAG
1034   LOCATE         18   -UEBERFLUG     , SP.ANF+(J- 1)*VZ + 1                :             PRINT   " "                                                     ;
1035   LOCATE         18   -UEBERFLUG     , SP.END+ J    *VZ                    :             PRINT   CHR$ (STOCKWERK1+48)
1036                                        FOR V=2  TO   DL              :NEXT
1037   NEXT                                                                     '
1041              J =  1                  : SP.NR=SP.NR+VZ*BETRAG 'abwrts ****
1042   WHILE          16   -UEBERFLUG +J  < 17-HOEHE%(NACH)
1043   LOCATE         16   -UEBERFLUG +J  , SP.NR:PRINT      ZEILE$(0)
1044   LOCATE         17   -UEBERFLUG +J  , SP.NR:PRINT      ZEILE$(STOCKWERK1)
1045              J = J+1
1046   WEND
1047                                                                     RETURN
1049 WEND   'Ausgabe       fr A.Nr.1                                                '
1999 '-------------------------------------------------------------------------      '     Ausgabe 2  listet Umsetzungen und deren zyklischen Binrcode              '-------------------------------------------------------------------------      '
2000 WHILE   AUSGABE       AND A.NR=2     : AUSGABE                      =FALSE
2001         PLATZ$(NACH) =PLATZ$(NACH)   + CHR$(N-STOCKWERK+49)                :            PLATZ$(VON)  =LEFT$(PLATZ$(VON),LEN(PLATZ$(VON))-1)                :            IF     NOT    INV2  THEN       LOCATE  7
2002 '       PRINT USING"   ###";SCHRITT; : PRINT TAB(12)PLATZ$(0)                                                                TAB(25)PLATZ$(1)                                                                TAB(38)PLATZ$(2)     TAB(51);
2003         PRINT USING"   ###";SCHRITT; : PRINT TAB(12)PLATZ$(START)                                                            TAB(25)PLATZ$(MITTE)                                                            TAB(38)PLATZ$(ZIEL ) TAB(51);
2004         FOR J=N TO 1  STEP -1        : PRINT WEGWEISER%(J);:NEXT    :PRINT
2005         FOR J=2 TO DL:NEXT           :                              RETURN
2009 WEND   'Ausgabe       fr A.Nr.2       2002  u. 6005 anstelle 2003 u. 6006      '       ordnen    die Pltze als A,B,C statt nach    Start, Mitte und Ziel      '       Die Wegweiser sind der in Zeile 3 erwhnte   Binrcode !!!!!!!!!!!      '
2999 '-------------------------------------------------------------------------      '     Ausgabe 3  druckt Umsetzungen und deren zyklischen Binrcode              '-------------------------------------------------------------------------      '
3000 WHILE   AUSGABE       AND A.NR=3     : AUSGABE                      =FALSE
3001  FOR J=0  TO  2:HOCH%(J)      =HOEHE%(J)    :NEXT                          :                    HOCH%(VON)    =HOEHE%(VON)-1:HOCH%(NACH)=HOEHE(NACH)+1
3002  DRUCKZEILE$   =      SPACE$(6-LEN   ( SCHRITT$))       +SCHRITT$+"      "                     +CHR$ (STOCKWERK+48)  +"   " +VON$+"   " +NACH$+ "        "
3003  DRUCKZEILE$   =DRUCKZEILE$+STR$     ( HOCH%(0)) +" "   +STR$(HOCH%(1))                        +      " "  +STR$     ( HOCH%(2))
3004  DRUCKZEILE$   =DRUCKZEILE$+"        "     +STR$((DREHUNG+3)MOD 3)+"     "
3005  FOR J=1 TO  N :DRUCKZEILE$=DRUCKZEILE$+" "+STR$((1-WEGWEISER%(J))\2)      :     NEXT  'Die Wegweiser sind der durch die Umsetzung erzeugte Binrcode !!!!             'Vergleiche Programmzeile 3
3006          LPRINT DRUCKZEILE$
3007                                                                     RETURN
3009 WEND   'Ausgabe       fr A.Nr 3     Anstelle Hoch%(..)  kann  man  ebenso      '                     in  3001 Hoehe%(..) ndern und in  3007  rcksetzen!      '
3999 '-------------------------------------------------------------------------      'Ausgabe 4  kombiniert die Ausgaben 1 und 3 : BERSICHT durch  WHILE Basic      '-------------------------------------------------------------------------      '
4000 WHILE  (BESCHRIFTUNG OR AUSGABE)   AND  A.NR=4
4001                                         A.NR=3                 :GOSUB  100
4002 IF NOT  LFD. THEN BESCHRIFTUNG=TRUE  :  LFD.=TRUE                                            ELSE AUSGABE     =TRUE
4003                                         A.NR=1                 :GOSUB  100                                           :  A.NR=4
4004                                                                     RETURN
4009 WEND   'Beschriftung o. Ausgabe    fr  A.Nr.4                                  '
4999 '-------------------------------------------------------------------------      '  Die Beschriftungen sind aus Zeitoptimierungsgrnden hintenangestellt         '-------------------------------------------------------------------------      '
5000 WHILE   BESCHRIFTUNG  AND A.NR=1 :CLS: BESCHRIFTUNG                 =FALSE
5001   LOCATE  3, 1 : PRINT STRING$(79,42) '*************  Beschriftung  ******
5002   LOCATE  4, 1 : PRINT"*      Umsetzung des " CHR$(N+48) "-stckigen "           "TURMs VON HANOI vom Fundament "      START$"  nach "ZIEL$ "      *
5003   LOCATE  5, 1 : PRINT STRING$(79,42)
5004   LOCATE 19, 1 : PRINT"=== Fundament A ===   === Fundament B ===   "     ;
5005                  PRINT"=== Fundament C ===   Schritt
5006   LOCATE  7,71 : PRINT"Stockwerk"    : LOCATE  8,74 : PRINT"von
5007   LOCATE  9,76 : PRINT"nach"         : LOCATE 18,67 : PRINT STRING$(3,24)  :      LOCATE 25, 5 : PRINT"Mit Tasten "    " <- / -> "                                             " schneller/langsamer   :   Verzgerungsfaktor "DL+(DL=1) ;
5008                                        ZEILE$(0)    ="                   "
5009                  FOR J =10 TO 18     : ZEILE$(J)    =""    :          NEXT                                            'ASCII 27/26 statt <-/-> ndern  die                                            'Druckersteuerung bei Shift + PrtScr
5010                  INV   =1   -INV      '--von Durchlauf zu Durchlauf hat---                                            'abwechselnd das unterste  Stockwerk                                            '------die Nummer 1 bzw N !!--------
5011   FOR J= 1 TO N: INV.T =INV *(N+1-J-J)'*************  Turmerzeugung  *****
5012   ZEILE$(J)    = SPACE$(9-(J+INV.T)) + STRING$(2*(J+INV.T)+1,J+48)                             + SPACE$(9-(J+INV.T))
5013   NEXT                                                                     '
5015   FOR J= 1 TO N: INV.T =INV *(N+1-J-J)'*************  Turmaufbau    ******
5016   LOCATE         18-J,1+22*START     : PRINT ZEILE$(N+1-J-INV.T)
5017   NEXT
5018   LOCATE         22  ,1:COLOR   0,7  : PRINT"    Start durch ENTER    "  ; :      WHILE INKEY$<>"":WEND:COLOR   7,0  : E$= ""   :WHILE NOT   E$ = CHR$(13) :      E$  = INKEY$    :WEND:LOCATE 22,1  : PRINT     SPACE$(25)     : RETURN
5019 WEND   'Beschriftung  fr A.Nr.1       Anstelle  ENTER auch  CONT+chr$(13)      '       Zeile  5018   lscht den Tastaturpuffer  adreunabhngig  !!!!!!!!      '
6000 WHILE   BESCHRIFTUNG  AND A.NR=2     :CLS   :BESCHRIFTUNG           =FALSE
6001         PLATZ$(START)=S.EIN$+": "    :PLATZ$(ZIEL)=Z.EIN$+": "             :            PLATZ$(MITTE)=CHR$(MITTE+65)                     +": "             :     FOR    J=1 TO N     :PLATZ$(START)  =PLATZ$(START)      +CHR$(J+48): NEXT
6002         PRINT  " Umsetzung des "CHR$(N+48)"-stckigen Turms von START ( "               START$ " )   nach ZIEL ( "ZIEL$" )"                         :PRINT
6003         PRINT  " Schritt   ----------- Teil - Trme ----------"                       TAB(51)" Stockwerksmarkierungen"                                        'Diese  Markierungen ergeben den erzeugten Binrcode (vgl. Zeile 3) !!!!!!      '
6004         MARKE$=" "   :FOR J=1 TO N   :MARKE$=MARKE$+"1  "           : NEXT :            LOCATE 25, 2 :PRINT          "Mit Tasten  "        "<- / ->"                    "    schneller // langsamer  :  Verzgerungsfaktor ="  DL+(DL=1) ;
6005         LOCATE  5, 1 :INV2 = -1-INV2 '--- von Durchlauf zu Durchlauf -----                                           '------- Wechsel zwischen -----------                                           '- laufender und ortsfester Ausgabe -
6006 '       PRINT  "     0"   TAB(12)     PLATZ$(0)                                                           TAB(25)     PLATZ$(1)                                                           TAB(38)     PLATZ$(2)           TAB(51)   MARKE$
6007         PRINT  "     0"   TAB(12)     PLATZ$(START)                                                       TAB(25)     PLATZ$(MITTE)                                                       TAB(38)     PLATZ$(ZIEL )       TAB(51)   MARKE$
6008                                                                     RETURN
6009 WEND   'Beschriftung  fr A.Nr.2       2002  u. 6006 anstelle 2003 u. 6007             'ordnen    d.  Pltze als A,B,C statt nach    Start, Mitte und Ziel             '
7000 WHILE   BESCHRIFTUNG  AND A.NR=3     : BESCHRIFTUNG                 =FALSE
7001         LPRINT
7002         LPRINT " #-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#"                    :       LPRINT" -"SPACE$(77)"-"
7003         LPRINT " #                           T U R M  VON  H A N O I                           #"                    :       LPRINT" -"SPACE$(77)"-"
7004         LPRINT " #             Umsetzung der ";N" Stockwerke vom Fundament  ";START$" auf ";ZIEL$"             #"    :       LPRINT" -"SPACE$(77)"-"
7005         LPRINT " #-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#"             :LPRINT:       LPRINT
7010         LPRINT "  Schritt   Stockwerk     Stockwerkshhe   Drehung   Wegweiser   -   Positionen" 'Die Wegweiser sind der  erzeugte Binrcode (vgl.Zeile  3)                      '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
7011         LPRINT "               von              auf                  (1  2  3  4     usw.     )
7012         LPRINT "                 nach         A  B  C"     :        LPRINT
7013         LPRINT "     0"SPACE$(23)HOEHE(0); HOEHE(1);HOEHE(2)SPACE$(15)   ; :            FOR J=1 TO N          :LPRINT    1-WEGWEISER%(J)  ;:          NEXT
7014                                                                     RETURN
7019 WEND   'Beschriftung  fr A.Nr.3                                                '
8999 '-------------------------------------------------------------------------      '  Das Ende der Ausgabe berichtet ber Zeitmessung und fhrt zu ABSCHLUSS       '-------------------------------------------------------------------------      '
9000 WHILE END.AUSGABE:END.AUSGABE                                       =FALSE
9001   IF  A.NR=4 THEN                                  ZEIT =TRUE  :GOSUB  100 :                      LPRINT:LPRINT" >> Text-Grafik    u n d   Listendruck <<" :                      LPRINT                         : DRUCK=TRUE  :GOSUB  100
9002   IF  A.NR=4 THEN LOCATE 21,1                                              :                             PRINT " >> Text-Grafik    u n d   Listendruck <<" :      LOCATE 17,66   : PRINT ZEILE$(17):LOCATE 23,1  : BILD =TRUE  :GOSUB  100
9003   IF  A.NR=3 THEN LPRINT:LPRINT    :CLS          : ZEIT =TRUE  :GOSUB  100 :                                                       DRUCK=TRUE  :GOSUB  100
9004   IF  A.NR=2 THEN  PRINT                         : ZEIT =TRUE  :GOSUB  100 :                                                       BILD =TRUE  :GOSUB  100
9005   IF  A.NR=1 THEN                                  ZEIT =TRUE  :GOSUB  100 :      LOCATE 17,66   : PRINT ZEILE$(17):LOCATE 21,1  : BILD =TRUE  :GOSUB  100
9006                                                                     RETURN
9009 WEND 'End.Ausgabe                                                               '
9010 WHILE ZEIT        :     ZEIT                                        =FALSE
9011                     ECHTZEIT!         =INT (ECHTZEIT!      *10+.5)  /   10
9012                     ECHTZEIT.LFD!     =INT (ECHTZEIT.LFD!  *10+.5)  /   10
9013       ECHTZEIT.H! = ECHTZEIT!         -     ECHTZEIT.LFD!
9014       PZEIT.AUSG! =(ECHTZEIT.LFD!     *100)/ECHTZEIT!
9015       PZEIT.HANOI!= 100               -     PZEIT.AUSG!
9016                                                                     RETURN
9019 WEND 'Zeit-Messung  fr den Algorithmus                                         '
9020 WHILE DRUCK       : DRUCK                                           =FALSE
9021      LPRINT USING " Laufzeiten in sec. :####.# (fr Berechnung  ## %)"  ;                          ECHTZEIT.H!            ,PZEIT.HANOI!                 ;
9022      LPRINT USING ",####.# (fr Ausgabe ### %)"                         ;                          ECHTZEIT.LFD!          ,PZEIT.AUSG!
9023      LPRINT USING " insgesamt  ####.#      "                             ;                          ECHTZEIT!
9024                                                                     RETURN
9029 WEND 'Druck-Ausgabe Zeit-Messung                                                '
9030 WHILE BILD        : BILD                                            =FALSE
9031       PRINT USING " Laufzeiten in sec   :###.# (fr Berechnung  ## %)"  ;                          ECHTZEIT.H!            ,PZEIT.HANOI!                 ;
9032       PRINT USING ",####.# (fr Ausgabe ### %)"                         ;                          ECHTZEIT.LFD!          ,PZEIT.AUSG!
9033       PRINT USING " insgesamt   ###.#      "                             ;                          ECHTZEIT!                                            ;
9034                                                                     RETURN
9039 WEND 'Bild -Ausgabe Zeit-Messung                                                '                                                                               '
9999 END  'Programm      H A N O I  fr  Helmut Karzel zum 22.01.1988
