'* ------------------------------------------------------- *
'*                  ADAPDEMO.BAS                           *
'* ------------------------------------------------------- *
DEFINT a-z
DIM x(19)
$INCLUDE "ADAPTER.INC"

'* ------------------------------------------------------- *
SUB Ueberschrift
  LOCATE 2,1
  PRINT SPACE$(1) + CHR$(201) + STRING$(76,205) + _
                    CHR$(187) + SPACE$(1)
  LOCATE 3,1
  PRINT SPACE$(1) + CHR$(186) + SPACE$(76) + _
                    CHR$(186) + SPACE$(1)
  LOCATE 4,1
  PRINT SPACE$(1) + CHR$(200) + STRING$(76,205) + _
                    CHR$(188) + SPACE$(1)
  titel$ = "Grafikadapter-ERMITTLUNGSPROGRAMM v 1.3" + _
           "  (c) 1989  Jrg Braun & TOOLBOX"
  LOCATE 3,((80 - (LEN(titel$))) \ 2) + 1
  PRINT titel$
END SUB
'* ------------------------------------------------------- *
SUB GrafikAdapter
  CALL Adapter(karte$, text, graphik, xmax, ymax)
  CALL Bildschirm(monitor$)
  ON ERROR GOTO 0
  SCREEN 0,0,0 : CLS
  IF karte$ <> "N/A" AND karte$ <> "MDA" THEN COLOR 0,7
  CALL Ueberschrift
  IF karte$ <> "N/A" AND karte$ <> "MDA" THEN COLOR 7,0
  x$ = CHR$(186)
  a = 24 : e = 56
  LOCATE 10, a : PRINT CHR$(201)+STRING$(31,205)+CHR$(187)
  LOCATE 11, a : PRINT x$"   Vorhandener Grafikadapter:"
  LOCATE 11, e : PRINT x$
  LOCATE 12, a : PRINT x$
  LOCATE 12,36
  SELECT CASE karte$
    CASE "MCG" : PRINT "MCGA-Karte";
    CASE "HGA" : PRINT "Hercules";
    CASE "JNR" : PRINT "PC Junior";
    CASE "OLI" : PRINT "Olivetti";
    CASE "N/A"
                 LOCATE 12,30
                 PRINT "unbekannt! Wert:"; FN RegWert
    CASE ELSE  : PRINT karte$"-Karte";
  END SELECT
  LOCATE 12, e : PRINT x$
  LOCATE 13, a : PRINT CHR$(199)+STRING$(31,196)+CHR$(182)
  LOCATE 14, a : PRINT x$
  LOCATE 14,33 : PRINT "Monitortyp: "; monitor$
  LOCATE 14, e : PRINT x$
  LOCATE 15, a : PRINT CHR$(199)+STRING$(31,196)+CHR$(182)
  LOCATE 16, a : PRINT x$" Textspeicher   :";
  IF KARTE$ = "N/A" THEN
    PRINT "   N/A"
  ELSE
    PRINT " ab HEX  "+ HEX$(text)
  END IF
  LOCATE 16, e : PRINT x$
  LOCATE 17, a : PRINT x$;" Graphikspeicher: ";
  IF karte$ = "N/A" OR karte$ = "MDA" THEN
    PRINT "  N/A"
  ELSE
    PRINT "ab HEX  " + HEX$(graphik)
  END IF
  LOCATE 17, e : PRINT x$
  LOCATE 18, a : PRINT x$" Maximal X-Achse:   ";
  IF karte$ = "N/A" OR karte$ = "MDA" THEN
    PRINT "N/A"
  ELSE
    PRINT xmax+1; "Pixel"
  END IF
  LOCATE 18, e : PRINT x$
  LOCATE 19, a : PRINT x$" Maximal Y-Achse:   ";
  IF karte$ = "N/A" OR karte$ = "MDA" THEN
    PRINT "N/A"
  ELSE
    PRINT ymax+1 "Pixel"
  END IF
  LOCATE 19, e : PRINT x$
  LOCATE 20, a : PRINT CHR$(200)+STRING$(31,205)+CHR$(188)
END SUB
'* ------------------------------------------------------- *
SUB PrintGraph
  CALL Bildschirm(monitor$)
  CALL Adapter(karte$, text, graphik, xmax, ymax)
  CALL Datum(datum$)
  LPRINT : LPRINT "Grafikadapter-ERMITTLUNGSPROGRAMM v 1.3"
  LPRINT "   (c) 1989  Jrg Braun & TOOLBOX"
  LPRINT "      Heute ist der "; datum$
  LPRINT STRING$(40,"-")
  LPRINT "Vorhandener Grafikadapter: ";
  SELECT CASE karte$
    CASE "MCG" : LPRINT "MCGA-Karte"
    CASE "HGA" : LPRINT "Hercules"
    CASE "JNR" : LPRINT "PC Junior"
    CASE "OLI" : LPRINT "Olivetti"
    CASE "N/A"
           LPRINT "nicht bekannt. Registerwert: "; FNREGWert
    CASE ELSE  : LPRINT karte$;"-Karte"
  END SELECT
  LPRINT STRING$(40,"-")
  LPRINT "Ermittelter Bildschirmtyp: "; monitor$; "-Monitor"
  LPRINT STRING$(40,"-")
  LPRINT "Daten der Grafikkarte:"
  LPRINT "    Textspeicher   : ab HEX  " + HEX$(text)
  IF karte$ <> "N/A" AND karte$ <> "MDA" THEN
    LPRINT "    Graphikspeicher: ab HEX  " + HEX$(graphik)
    LPRINT "    Maximal X-Achse:   "; xmax+1; "Punkte"
    LPRINT "    Maximal Y-Achse:   "; ymax+1; "Punkte"
  END IF
END SUB
'* ------------------------------------------------------- *
SUB Datum(datum$)
LOCAL tag$, monat$, jahr$
          ' Umformen des Systemdatums in das deutsche Format
          ' und Entfernen fhrender Nullen.
  jahr$  = RIGHT$(DATE$,4)
  monat$ = LEFT$(DATE$,2)
  IF LEFT$(monat$,1) = "0" THEN monat$ = RIGHT$(monat$,1)
  tag$ = MID$(DATE$,4,2)
  IF LEFT$(tag$,1) = "0" THEN tag$ = RIGHT$(tag$,1)
  datum$ = tag$ + "." + monat$ + "." + jahr$
END SUB
'* ------------------------------------------------------- *
SUB Info
  PRINT : COLOR 15 : PRINT
  PRINT "* ADAPTER V.1.3 * (c) 1989 J. Braun und Toolbox "
  COLOR 7
  PRINT "Programm zur Ermittlung des Grafikadapters";_
        " und der maximal mglichen Grafik-
  PRINT "auflsung des Bildschirms."
  PRINT "Mit der Option /D oder /P erfolgt parallel";_
        " ein Ausdruck auf dem Drucker."
  PRINT
END SUB
'* ------------------------------------------------------- *
DEF FN PrintFlag
SHARED pr$
  IF INSTR(1,pr$,"P") > 0 OR INSTR(1, pr$, "D") > 0 _
    THEN FN PrintFlag = -1
END DEF
'* ------------------------------------------------------- *
DEF FN Infoflag
SHARED pr$
  IF INSTR(1,pr$,"?") > 0 THEN FN Infoflag = -1
END DEF

'* -------------------  Hauptprogramm  ------------------- *

pr$ = UCASE$(COMMAND$)
ON ERROR GOTO Ende
IF FNPrintFlag THEN CALL PrintGraph
IF FN Infoflag THEN
  CALL INFO
  WHILE INKEY$ = "" : WEND
ELSE
  CALL Datum(datum$)
  CALL GrafikAdapter
  LOCATE 5,1 : PRINT " "; datum$
  WHILE a$ = ""
    a$ = INKEY$
    LOCATE 5,72 : PRINT TIME$
  WEND
  LOCATE 23,1,0
END IF

Ende:
END
'* ------------------------------------------------------- *
'*              Ende von  ADAPTER.BAS                      *

