(* ------------------------------------------------------ *)
(*                  HOTKDEMO.PAS                          *)
(*  ... demonstriert die Fhigkeiten der Unit HOTKEY      *)
(*           (c) 1989 Jan Hargens & TOOLBOX               *)
(* ------------------------------------------------------ *)
PROGRAM HotkeyDemo;

USES Crt, HotKey;

CONST
  F1_Code = $3b00;
  F2_Code = $3c00;

VAR
  FrameColor : BYTE;
  Abbruch    : BOOLEAN;
  s          : STRING[60];

{$F+}                            { FAR-Codierung notwendig }
  PROCEDURE RewriteFrame;
  CONST
    Box = #219;
  VAR
    x, y, Count, Count2  : BYTE;
    Wmin, Wmax, AttrSave : WORD;
  BEGIN
    x        := WhereX;     y    := WhereY;
    WMin     := WindMin;    WMax := WindMax;
    WindMin  :=0;        WindMax := $FFFF; { kein Scrollen }
    AttrSave :=TextAttr;
    Inc(FrameColor);
    IF FrameColor > 15 THEN FrameColor := 1;
    TextAttr := (TextAttr AND $F0) OR FrameColor;
    FOR count := 0 TO 1 DO BEGIN
      GotoXY(1, count*24 + 1);
      FOR count2 := 1 TO 80 DO Write(Box);
    END;
    FOR count := 2 TO 24 DO
      FOR count2 := 0 TO 1 DO BEGIN
        GotoXY(count2*79 + 1, count);
        Write(Box);
      END;
    TextAttr := AttrSave;
    WindMin := WMin; WindMax := WMax;
    GotoXY(x,y);
  END;

  PROCEDURE SetFlag;
  BEGIN
    Abbruch := TRUE;
    DeleteHotkey(F1_Code);    { keine Farbverstellung mehr }
  END;
{$F-}

BEGIN
  ClrScr;
  WriteLn(^J' Hotkeydemo (c) 1989 Jan Hargens & TOOLBOX');
  Abbruch := FALSE;
  FrameColor := 1;
  GotoXY(10,21);
  Write(' Fr Abbruch <F2> Return tippen');
  Window(10, 10, 41, 20);
  AddHotkey(F1_Code, RewriteFrame);
  AddHotkey(F2_Code, SetFlag);
  REPEAT
    ReadLn(s);
  UNTIL Abbruch;
  ClrScr;
END.
(* ------------------------------------------------------ *)
(*               Ende von HOTKDEMO.PAS                    *)