(* ------------------------------------------------------ *)
(*                      READ.PAS                          *)
(*        (c) 1989 J.Laitenberger & TOOLBOX               *)
(* ------------------------------------------------------ *)
PROGRAM ReadProtect;

VAR
  f1, f2   : FILE;
  gel, ges : WORD;
  puf      : ARRAY [1..2048] OF CHAR;
  b        : BYTE;

BEGIN
  IF ParamCount <> 2 THEN Halt;
  Assign(f1, ParamStr(1));
{$I-}
  Reset (f1,1);
{$I+}
  IF IOResult <> 0 THEN BEGIN
    WriteLn('Datei nicht gefunden!');
    Halt;
  END;
  Assign(f2, ParamStr(2));
  Rewrite(f2,1);
  REPEAT
    BlockRead(f1, b, 1)
  UNTIL b = 26;
  REPEAT
    BlockRead(f1, puf, SizeOf(puf), gel);
    BlockWrite(f2, puf, gel, ges)
  UNTIL (gel = 0) OR (gel < 2048);
  Close(f1);
  Close(f2);
END.
(* ------------------------------------------------------ *)
(*                  Ende von READ.PAS                     *)