* -------------------------------------------------------- *
*                    D_MENU.PRG                            *
*    Demo der Mglichkeiten der Mentechnik in dBase IV    *
*            (c) 1989 E.Schubert & TOOLBOX                 *
* -------------------------------------------------------- *
* Die erste Option des Zeilenmens "HAUPT" aktiviert sofort
* POPUP-Men "FIRST".                                                        
* Dieses Men listet alle verfgbaren *.dbf - Dateien auf 
* und bietet die Mglichkeit, eine Datenbank auszuwhlen. 
* Wird die Wahl durch <RETURN> besttigt, wird die gewhlte 
* Datenbank geffnet, das POPUP-Men "SECOND" listet die 
* verfgbaren Felder der aktuellen Datenbank auf. Nach 
* Auswahl eines Feldes listet das POPUP-Men "THIRD" alle 
* Werte des gewhlten Feldes auf.                                                                       *
* Die zweite Option des Hauptmens dient nur zur Kontrolle 
* der gewhlten Werte - an dieser Stelle sind der Phantasie 
* keine Grenzen gesetzt, wie die Variablen 
*            db_val   = gewhlte Datenbank                                    
*            feld_val = gewhltes Feld                                        
*            wert_val = gewhlter Wert                                        
* in Anwendungsprogrammen sinnvoll eingebunden werden knnen                 
* -------------------------------------------------------- *

SET SCOREBOARD OFF
SET STATUS     OFF
SET TALK       OFF
SET MESSAGE    TO
@ 0,0 CLEAR

* Variablen fr Auswahl in den folgenden Mens vorbelegen 
  dbval   = 'NO_DBank'
  feldval = 'NO_FIELD'
  wertval = 'NO_WERT'

* Zeilenmen definieren
  DEFINE menu haupt
  DEFINE pad haupt_1 OF haupt PROMPT ;
         "Datenbank auswhlen" at 4,2;
         MESSAGE "Auswahl der Datenbank mit " + ;
         "Pfeiltasten, besttigen mit RETURN"
  DEFINE pad haupt_2 OF haupt PROMPT ;
         "Gewhlte Werte anzeigen" at 4,32
  DEFINE pad haupt_3 OF haupt PROMPT "ENDE" AT 4,62

* Cursor auf der Option "Datenbank auswhlen" aktiviert 
* sofort das erste POPUP-Men
  ON pad haupt_1 OF haupt ACTIVATE POPUP first

* im Unterschied dazu mu die Anwahl der zweiten Option 
* mit RETURN besttigt werden
  ON SELECTION pad haupt_2 OF haupt DO zeigen

* geht sofort zur db-Punkt-Ebene zurck, in Anwendungs-
* programmen sollte hier besser eine Prozedur stehen, die 
* die SET-Befehle auf die Standardwerte zurcksetzt
  ON SELECTION pad haupt_3 OF haupt RETURN

* erstes POPUP-Men soll alle Datenbanken auflisten
  DEFINE POPUP first from 6,3 PROMPT FILES LIKE *.dbf
  ON SELECTION POPUP first DO anz

* Hauptmen aktivieren
  ACTIVATE menu haupt

* EOP d_menu.prg


PROCEDURE anz
* wird bei Auswahl einer Datenbank im 1. POPUP aufgerufen
  dbval = prompt()
* Funktion prompt() merkt gewhlte Option, hier die 
* ausgewhlte Datenbank, die mit dem folgenden Befehl 
* geffnet wird
  use &dbval.
* das nchste Men zeigt die Felder der Datenbank
  DEFINE POPUP second FROM 8,20 PROMPT STRUCTURE
  ON SELECTION POPUP second DO anz1
  ACTIVATE POPUP second
  DEACTIVATE POPUP
RETURN

PROCEDURE anz1
* wird bei Auswahl eines Feldes im 2. POPUP aufgerufen
  feldval = prompt()
* feldval nimmt das gewhlte Feld auf
* das nchste Men listet den Inhalt des angewhlten Feldes
  DEFINE POPUP third FROM 10,30 PROMPT FIELD &feldval.
  ON SELECTION POPUP third DO ende
  ACTIVATE POPUP third
  DEACTIVATE POPUP
RETURN

PROCEDURE ende
* wird bei Auswahl eines Feldinhaltes im dritten 
* POPUP - Men aufgerufen
  wertval = prompt()
  DEACTIVATE POPUP
RETURN

PROCEDURE zeigen
* wird bei Auswahl der Option " Gewhlte Werte anzeigen" 
* im Hauptmen aktiviert dient hier nur zur Demonstration 
* und zur Kontrolle der Auswahl
  @ 5,0 clear
  ? "Gewhlte Datenbank : " + dbval
  ? "Gewhltes Feld     : " + feldval
  ? "Gewhlter Wert     : " + wertval
RETURN

* -------------------------------------------------------- *
*                 Ende von D_MENU.PRG                      *                        
