(* ------------------------------------------------------ *)
(*                   TURBOPTR.PAS                         *)
(*  Prozeduren zum direkten Speicherzugriff mit Hilfe von *)
(*  POINTERn.                                             *)
(*          (c) 1989  H.Zorba  &  TOOLBOX                 *)
(* ------------------------------------------------------ *)
UNIT TurboPtr;

INTERFACE

   { Pointer P inkrementieren bzw. dekrementieren }

PROCEDURE IncPtr( VAR P : POINTER; Increment : WORD );

PROCEDURE DecPtr( VAR P : POINTER; Decrement : WORD );

   { Von P adressiertes Wort bzw. Byte holen }

PROCEDURE GetWPtr( P : POINTER; VAR Destination : WORD );

PROCEDURE GetBPtr( P : POINTER; VAR Destination : BYTE );

   { Wort bzw. Byte in von P adressierte Speicherstelle
     schreiben }

PROCEDURE PutWPtr( P : POINTER; NewValue : WORD );

PROCEDURE PutBPtr( P : POINTER; NewValue : BYTE );


IMPLEMENTATION

PROCEDURE IncPtr; EXTERNAL;

PROCEDURE DecPtr; EXTERNAL;

PROCEDURE GetWPtr; EXTERNAL;

PROCEDURE GetBPtr; EXTERNAL;

PROCEDURE PutWPtr; EXTERNAL;

PROCEDURE PutBPtr; EXTERNAL;

{$L TURBOPTR.OBJ}

BEGIN
END.
(* ------------------------------------------------------ *)
(*               Ende von TURBOPTR.PAS                    *)