(* ------------------------------------------------------ *)
(*                   PINTEST.PAS                          *)
(*    Testet alle 24 Nadeln Des NEC - PINWRITER P2200     *)
(*         (c) 1989  Robert Knecht & TOOLBOX              *)
(* ------------------------------------------------------ *)
PROGRAM PinTest;

USES Dos, Printer;

VAR
  col_1, col_2, col_3, col_4 : BYTE;
  i, ii : INTEGER;

  PROCEDURE SetMode;
                 { allgemeine Initialisierung Des Druckers }
  BEGIN
    Write(LST, #27, #64, #10);        { = RESET            }
    Write(LST, #27, '*', #40, #96, #9);
                 { = QUAD DENSITY, 96+(9*256) = 2400 BYTES }
  END;

  PROCEDURE Cyclo; { Vertauscht die Druckkolonnen zyklisch }
  BEGIN
    col_4 := col_3;
    col_3 := col_2;
    col_2 := col_1;
    col_1 := col_4;
  END;

  PROCEDURE Init;
  BEGIN
    col_1 := 1;
    col_2 := 0;
    col_3 := 0;
    col_4 := 0;  { Startwerte }
    WriteLn;
    WriteLn('      --------------------------------------',
            '------------------'); { 6 Spaces, 56 Striche }
    WriteLn;
    WriteLn('       ALLE 24 NADELN DES NEC - P2200 WERDEN',
            ' EINZELN GETESTET ');
    WriteLn;
    WriteLn('      --------------------------------------',
            '------------------');
  END;

  PROCEDURE Write_3Byte;
  BEGIN
    FOR ii := 1 TO 100 DO BEGIN
                       { JE 100 PUNKTE DER AKTUELLEN NADEL }
      Write(LST, Chr(col_1), Chr(COL_2), Chr(col_3));
    END;
  END;

  PROCEDURE Count;
  BEGIN
    FOR i := 1 TO 24 DO BEGIN                  { 24 NADELN }
      Write_3Byte;
      IF NOT ((col_3 = 0) OR (col_3 = 128)) THEN BEGIN
        col_3 := 2 * col_3;
      END;
      Cyclo;
    END;
  END;

BEGIN
  Init;
  SetMode;
  Count;
  Write(LST, #13, #10, #27, #64);
                        { Zeilenvorschub und Drucker-Reset }
END.
(* ------------------------------------------------------ *)
(*                 Ende von PINTEST.PAS                   *)
