(* ------------------------------------------------------ *)
(*                 VIDEORAM.PAS                           *)
(* Abspeichern des HGC-RAMs (Seite eins) in einer Datei   *)
(*      (C) 1989 Erich Cadario Jr. & TOOLBOX              *)
(* ------------------------------------------------------ *)
PROGRAM VideoRAM;

TYPE
  f = FILE OF CHAR;

  FUNCTION Hoch(potenz, wert : INTEGER) : INTEGER;
  VAR
    h1, h2 : INTEGER;
  BEGIN
    h1 := 1;
    FOR h2 := 1 TO potenz DO h1 := h1 * 2;
    hoch := h1 * wert;
  END;

  PROCEDURE RAMUmwandeln;
  VAR
    datei           : f;
    bte             : ARRAY [0..89,0..7] OF INTEGER;
    rest            : ARRAY [0..7] OF INTEGER;
    zahl            : ARRAY [0..719] OF INTEGER;
    i,  j,  k,  l,
    lauf,  LOOP,
    hilfe,  help    : INTEGER;
    c               : CHAR;

  BEGIN
    Assign(datei, 'pixels.bte');
    Rewrite(datei);
    LOOP := 0;
    WHILE LOOP < 7740 DO BEGIN
      FOR j := 0 TO 3 DO
        FOR k := 0 TO 89 DO
          bte[k,j] := Mem[$B000:LOOP+j*8192+k];
      FOR j := 0 TO 3 DO
        FOR k := 0 TO 89 DO
          bte[k,j+4] := Mem[$b000:LOOP+90+j*8192+k];
      lauf := 7;
      FOR j := 0 TO 89 DO BEGIN
        FOR k:=0 TO 7 DO BEGIN
          zahl[lauf-k] := 0;
          FOR l := 0 TO 7 DO BEGIN
            hilfe := bte[j,l];
            rest[l] := bte[j,l] MOD 2;
            bte[j,l] := hilfe DIV 2;
            help := hoch(7-l, rest[l]);
            zahl[lauf-k] := zahl[lauf-k] + help;
          END;
        END;
        lauf := lauf + 8;
      END;
      FOR j := 0 TO 719 DO BEGIN
        CASE zahl[j] OF
          27: zahl[j] := zahl[j] - 2;
          ELSE;
        END;
        c := Chr(zahl[j]);
        Write(datei, c);
      END;
      LOOP := LOOP + 180;
    END;
    LOOP := 7740;
      FOR j := 0 TO 3 DO
        FOR k := 0 TO 89 DO
          bte[k,j] := Mem[$b000:j*8192+LOOP+k];
      FOR j := 0 TO 3 DO
        FOR k := 0 TO 89 DO bte[k,j+4]:=0;
      lauf := 7;
      FOR j := 0 TO 89 DO BEGIN
        FOR k := 0 TO 7 DO BEGIN
          zahl[lauf-k] := 0;
          FOR l := 0 TO 7 DO BEGIN
            hilfe := bte[j,l];
            rest[l] := bte[j,l] MOD 2;
            bte[j,l] := hilfe DIV 2;
            help := hoch(7-l, rest[l]);
            zahl[lauf-k] := zahl[lauf-k] + help;
          END;
        END;
        lauf := lauf + 8;
      END;
      FOR j := 0 TO 719 DO BEGIN
        c := Chr(zahl[j]);
        Write(datei, c);
      END;
    Close(datei);
  END;

BEGIN
   RAMUmwandeln;
END.
(* ------------------------------------------------------ *)
(*                Ende von VIDEORAM.PAS                   *)