/*********************************************************/
/*                      COPROCES.H                       */
/*        Headerdatei fr Coprocesse in LATTICE C        */
/*           (C) 1988 Roland Mosler & TOOLBOX            */
/*********************************************************/

typedef struct _process
                        {
                          int D0,D1,D2,D3,D4,D5,D6,D7,
                              A0,A1,A2,A3,A4,A5,A6,A7 ;
                        } PROCESS ;




extern int newproc( void (*)(), char *, int, PROCESS * ) ;
extern int transfer( PROCESS *,PROCESS *) ;

/*********************************************************

  Functionheadings :

  int newproc( function,buffer,size,proc )
    void    (*function)() ;
    char    *buffer ;
    int     size ;
    PROCESS *proc ;

  return : buffer+size-4

  int  transfer( old,new )
    PROCESS *old,*new ;

  return : new.D0  ( was sonst ? )

*********************************************************/
