(* ------------------------------------------------------ *)
(*                    ZEITISIN.PAS                        *)
(* ------------------------------------------------------ *)
{$I PCTIME.INC  }
{$I ISINCOS.BIB }

CONST n    : INTEGER = 5000;
      grad : INTEGER =   55;

VAR   j, g, k : INTEGER;
      x, y    : REAL;

BEGIN
  g := grad;
  x := grad/180 * pi;
  WriteLn(#10,'Zeitmessung fuer Isin, Rsin, sin',#10);
  ResetTime;
  FOR j := 1 TO n DO k := Isin(g);
  WriteLn(TimeStr:10, ' fuer schnelle Isin- Routine       ',
          k);
  ResetTime;
  FOR j := 1 TO n DO y := Rsin(x);
  WriteLn(TimeStr:10,' fuer          Rsin- Routine     ',y);
  ResetTime;
  FOR j := 1 TO n DO y := Sin(x);
  WriteLn(TimeStr:10,' fuer implementierte Sinusroutine',
          y);
end.
(* ------------------------------------------------------ *)
(*               Ende von ZEITISIN.PAS                    *)