(* ------------------------------------------------------ *)
(*                   UHRTEST.PAS                          *)
(* ------------------------------------------------------ *)
PROGRAM Uhrtest;

USES Crt, Stoppuhr;

VAR a,b    : ChronoPtr;                       { Stoppuhren }
    za,zb  : REAL;
    ch     : CHAR;
    fertig : BOOLEAN;

BEGIN
                               {-- Stoppuhren einrichten --}
  NewChronometer(a);   NewChronometer(b);
  ResetChronometer(a); ResetChronometer(b);
  ClrScr;
  GotoXY(20,1); Write('  Uhr 1 ');
  GotoXY(40,1); Write('  Uhr 2 ');
  za := 0;  GotoXY(20,3);  Write(za:6:2);
  zb := 0;  GotoXY(40,3);  Write(zb:6:2) ;
  GotoXY(1,5);  Write('START MIT ');
  GotoXY(22,5); Write('s') ;
  GotoXY(42,5); Write('S') ;
  GotoXY(1,6);  Write('RESET MIT ');
  GotoXY(22,6); Write('r') ;
  GotoXY(42,6); Write('R') ;
  GotoXY(1,7);  Write('STOP  MIT ');
  GotoXY(22,7); Write('h') ;
  GotoXY(42,7); Write('H') ;
  GotoXY(1,9);
  Write('Demonstration mit <SPACE> beenden');

  fertig := FALSE;  ch := 'x';
  WHILE NOT fertig DO BEGIN
    IF KeyPressed THEN ch := ReadKey;
    CASE ch OF
      's' :  StartChronometer(a);
      'S' :  StartChronometer(b);
      'h' :  StopChronometer(a) ;
      'H' :  StopChronometer(b) ;
      'r' :  ResetChronometer(a);
      'R' :  ResetChronometer(b);
      ' ' :  fertig := TRUE ;
    ELSE { nichts } ;
    END ;
    ch := 'x';
    ReadChronometer(a, za);
    ReadChronometer(b, zb);
    GotoXY(20,3);  Write(SecToTime(za));
    GotoXY(40,3);  Write(SecToTime(zb));
  END;
  DisposeChronometer(a);
  DisposeChronometer(b);
END.
(* ------------------------------------------------------ *)
(*                Ende von UHRTEST.PAS                    *)

