(* --------------------------------------------------- *)
(*                   MCGADEMO.MOD                      *)
(*                (C) 1989 TOOLBOX                     *)
(* --------------------------------------------------- *)
MODULE MCGADemo;

FROM Lib IMPORT Delay;
FROM IO IMPORT RdKey, KeyPressed;
IMPORT MCGA;

VAR
  x, y                    : INTEGER;
  color, rot, gruen, blau : CARDINAL;
  c                       : CHAR;
  regbuf                  : MCGA.ColorRegBuffer;
  i                       : LONGINT;

BEGIN
  MCGA.initgraphic;
  MCGA.clearscreen (203);
  FOR x := 16 TO 160 DO
    MCGA.box(x, x, 319-x, 199-x, x);
  END;
  x := 16; y := 1;
  REPEAT
    INC(x, y);
    IF (x = 16) OR (x = 31) THEN
      y := -y;
    END;
    MCGA.setcursor(10, 12);
    MCGA.print(' MCGA = 256 Farben ',x);
    Delay(20);
  UNTIL KeyPressed();
  c := RdKey();

  color := 1;
  FOR y := 0 TO 199 DIV 5 DO
    MCGA.line(0, 100, 319, y*5, color);
    INC(color);
  END;

  FOR y := 0 TO 199 DIV 5 DO
    MCGA.line(0, y*5, 319, 100, color);
    INC(color);
  END;

  Delay(2000);

  MCGA.mcgasave('test2.scr');
  MCGA.clearscreen(255);
  Delay(2000);
  MCGA.mcgaload('test2.scr');
  Delay(2000);

  MCGA.colorbox(0, 190, 319, 199, 150);
  (* Eine Farbe variieren *)
  c := CHAR(0);
  i := 0;
  WHILE (i < 262144) AND (c = CHAR(0)) DO
    INC(i);
    MCGA.readcolor(150, rot, gruen, blau);
    INC(blau);
    IF blau > 63 THEN
      blau := 0;
      INC(gruen);
      IF gruen > 63 THEN
        gruen := 0;
        INC(rot);
        IF rot > 63 THEN
          rot := 0;
        END;
      END;
    END;
    MCGA.setcolor(150, rot, gruen, blau);
    IF KeyPressed() THEN
      c := RdKey();
    END;
  END;

  MCGA.clearscreen(255);
  FOR x := 16 TO 160 DO
    MCGA.box(x, x, 319-x, 199-x, x);
  END;

  (* Alle Farben "cyclen" *)
  rot := 0;
  gruen := 0;
  blau := 0;
  FOR color := 0 TO 255 DO
    regbuf[color].b := SHORTCARD(blau);
    regbuf[color].g := SHORTCARD(gruen);
    regbuf[color].r := SHORTCARD(rot);
    INC(blau,15);
    IF blau > 63 THEN
      blau := 0;
      INC(gruen,15);
      IF gruen > 63 THEN
        gruen := 0;
        INC(rot,15);
        IF rot > 63 THEN
          rot := 0;
        END;
      END;
    END;
  END;

  MCGA.setcolorblock(0, regbuf, 256);

  WHILE NOT KeyPressed() DO
    FOR color := 0 TO 255 DO
      INC(regbuf[color].b, 15);
      IF regbuf[color].b > 63 THEN
        regbuf[color].b := 0;
        INC(regbuf[color].g, 15);
        IF regbuf[color].g > 63 THEN
          regbuf[color].g := 0;
          INC(regbuf[color].r, 15);
          IF regbuf[color].r > 63 THEN
            regbuf[color].r := 0;
          END;
        END;
      END;
    END;
    MCGA.setcolorblock(0, regbuf, 256);
  END;

  MCGA.exitgraphic;
END MCGADemo.
