(* ------------------------------------------------------ *)
(*                   DESIGN.PAS                           *)
(*        erstellt mengesteuert die CONFIG.SYS           *)
(*         (c) 1989 Klaus Vollmer  &  TOOLBOX             *)
(* ------------------------------------------------------ *)
PROGRAM Design;

USES Crt;

CONST
  Datei = 'CONFIG.SYS';             { zu erstellende Datei }

VAR
  ch, lw, inp                  : CHAR;
  zeile                        : STRING[80];
  f                            : TEXT;
  br, bu, co, ded, dea, fi, la : BOOLEAN;
  i, pb, rdg, gd, lv           : INTEGER;

  FUNCTION Menu : CHAR;
  VAR
    chm : CHAR;
  BEGIN
    REPEAT
      chm := ReadKey;
      chm := UpCase(chm);
    UNTIL chm IN ['1', '2', '3', '4', '5', '6', '8', '0'];
    IF chm = '8' THEN Halt;
    Menu := chm;               { Tastenwert wird bergeben }
  END;

  PROCEDURE Create(chc : CHAR);
  BEGIN
    GotoXY(6,20);
    CASE chc OF    { Werte fr CONFIG.SYS werden eingelesen }
      '1' : br := TRUE;
      '2' : BEGIN
              bu := TRUE;
              Write('Pufferbereich (2-255) : ');
              ReadLn(pb);
            END;
      '3': BEGIN
             co := TRUE;
             Write('Tastaturbelegung (Lndervorwahl) : ');
             ReadLn(lv);
           END;
      '4': BEGIN
             ded := TRUE;
             Write('Ramdisk-Gre (16<) : ');
             ReadLn(rdg);
             GotoXY(6,21);
             Write('Ansi-Treiber (j/n) : ');
             ReadLn(inp);
             IF UpCase(inp) = 'J' THEN dea := TRUE;
           END;
      '5': BEGIN
             fi := TRUE;
             Write('geffnete Dateien (8-255) : ');
             ReadLn(gd);
           END;
      '6': BEGIN
             la := TRUE;
             Write('max. Laufwerke (a-z) : ');
             ReadLn(lw);
           END;
    END;
    GotoXY(1,20);
    DelLine;  DelLine;
  END;

  PROCEDURE WriteFile;
  BEGIN          { Werte fr CONFIG.SYS werden geschrieben }
    Assign(f, Datei);
    Rewrite(f);
    IF br  THEN WriteLn(f, 'BREAK=ON');
    IF bu  THEN WriteLn(f, 'BUFFERS=', pb);
    IF co  THEN WriteLn(f, 'COUNTRY=', lv);
    IF dea THEN WriteLn(f, 'DEVICE=ANSI.SYS');
    IF ded THEN WriteLn(f, 'DEVICE=RAMDRIVE.SYS ', rdg);
    IF fi  THEN WriteLn(f, 'FILES=', gd);
    IF la  THEN WriteLn(f, 'LASTDRIVE=', UpCase(lw));
    Close(f);
  END;

BEGIN
  ClrScr;
  GotoXY(27,1);
  WriteLn('CONFIG.SYS - Designer ');
  GotoXY(24,2);
  WriteLn('(c) 1989 Klaus Vollmer & TOOLBOX ');
  GotoXY(23,3);
  FOR i:=1 TO 36 DO Write('-');
  GotoXY(18,5);
  WriteLn('Zum Beenden des Programms <0> drcken.');
  GotoXY(15,7);
  WriteLn('1 - BREAK          2 - BUFFERS',
          '          3 - COUNTRY');
  GotoXY(15,9);
  WriteLn('4 - DEVICE         5 - FILES',
          '            6 - LASTDRIVE');
  GotoXY(6,12);
  WriteLn('Bitte eine der Nummern fr die Aufnahme ',
          'des jeweiligen Punktes in die');
  GotoXY(6,14);
  WriteLn('CONFIG.SYS - Datei, eingeben.',
          '       PROGRAMM ABBRUCH: 8 Taste drcken.');
  br  := FALSE; bu  := FALSE; co :=FALSE;
  ded := FALSE; dea := FALSE; fi :=FALSE; la := FALSE;
  REPEAT
    ch := Menu;
    IF ch <> '0' THEN Create(ch);
  UNTIL ch = '0';
  WriteFile;
  ClrScr;
  WriteLn('Neuer Inhalt :');
  WriteLn;
  Assign(f, Datei);
  Reset(f);
  FOR i := 1 TO 7 DO BEGIN  { Neuer Inhalt wird ausgelesen }
    ReadLn(f, zeile);
    WriteLn(zeile);
  END;
  Close(f);
  REPEAT UNTIL KeyPressed;
  ClrScr;
  WriteLn('Programm beendet');
END.
(* ------------------------------------------------------ *)
(*                 Ende von DESIGN.PAS                    *)