(* ------------------------------------------------------ *)
(*                Druckerstatus abfragen                  *)
(* ------------------------------------------------------ *)
FUNCTION Printer_Ready : BOOLEAN:
VAR
  Regs : Registers;

BEGIN
  WITH Regs DO BEGIN
    ah := 2;
    dx := 0;
  END;
  Intr($17, Regs);
  IF Regs.ah in [144,16,80,208] THEN
    Printer_Ready := TRUE
  ELSE BEGIN
    TextColor(White);
    TextBackGround(Red);
    GotoXY(17,23);
    Write('Drucker nicht bereit oder nicht angeschlossen');
    GotoXY(17,24);
    Write('Bitte beheben und noch einmal versuchen...');
    REPEAT UNTIL KeyPressed;
    TextBackGround(Black);
    GotoXY(1,23);
    ClrEOL;
    GotoXY(1,24);
    ClrEOL;
    Printer_Ready := FALSE;
  END;
END;
(* ------------------------------------------------------ *)
(*                 Ende von DRUCKER.PAS                   *)
