'* ------------------------------------------------------- *
'*                     ACCDTA.BAS                          *
'* ------------------------------------------------------- *
TYPE FileType
  FileName AS STRING * 12
  FileAtt AS INTEGER
  FileSize AS LONG
  FileDate AS STRING * 10
  FileTime AS STRING * 8
END TYPE

SUB FileData (DTA$, File AS FileType) STATIC

  temp$ = MID$(DTA$, 31) + CHR$(0)
  File.FileName = LEFT$(temp$, INSTR(temp$, CHR$(0)) - 1)

  File.FileAtt = ASC(MID$(DTA$, 22, 1))

  File.FileSize = CVL(MID$(DTA$, 27, 4))

  temp& = CVI(MID$(DTA$, 25, 2))
  d = temp& AND &H1F
  m = (temp& \ 32) AND &HF
  y = ((temp& \ 512) AND &H1F) + 1980
  d$ = LTRIM$(STR$(d))
  IF LEN(d$) = 1 THEN d$ = "0" + d$
  m$ = LTRIM$(STR$(d))
  IF LEN(m$) = 1 THEN m$ = "0" + m$
  File.FileDate = d$ + "." + m$ + "." + STR$(y)

  temp& = CVI(MID$(DTA$, 23, 2))
  IF temp& < 0 THEN temp& = temp& + 65536
  h = (temp& \ 2048) AND &H1F
  m = (temp& \ 32) AND &H3F
  s = temp& AND &H1F
  h$ = LTRIM$(STR$(h))
  IF LEN(h$) = 1 THEN h$ = "0" + h$
  m$ = LTRIM$(STR$(m))
  IF LEN(m$) = 1 THEN m$ = "0" + m$
  s$ = LTRIM$(STR$(s))
  IF LEN(s$) = 1 THEN s$ = "0" + s$
  File.FileTime = h$ + ":" + m$ + ":" + s$

END SUB
'* ------------------------------------------------------- *
'*                   Ende von ACCDTA.BAS                   *
