(* ------------------------------------------------------ *)
(*                  HGCMOUSE.PAS                          *)
(* Spezielle Initialisierung der Maus fr den Grafikmodus *)
(*       (C) 1989 Maximilian Mayr & TOOLBOX               *)
(* ------------------------------------------------------ *)
UNIT HGCMouse;

INTERFACE

USES Crt, Dos, Graph;

  PROCEDURE Init_Mouse;
  PROCEDURE ShowMouse;
  PROCEDURE HideMouse;
  FUNCTION  Mouse_Status(VAR x, y : INTEGER) : INTEGER;

IMPLEMENTATION

CONST
  mintr = 51;

VAR
  Regs : Registers;

  PROCEDURE Init_Mouse;
  BEGIN
    Regs.ax := 0;
    Intr(mintr, Regs);
  END;

  PROCEDURE ShowMouse;
  BEGIN
    Regs.ax := 1;
    Intr(mintr, Regs);
  END;

  PROCEDURE HideMouse;
  BEGIN
    Regs.ax := 2;
    Intr(mintr, Regs);
  END;

  FUNCTION Mouse_Status(VAR x, y : INTEGER) : INTEGER;
  BEGIN
    Regs.ax := 3;
    Intr(mintr, Regs);
    x := Regs.cx;
    y := Regs.dx;
    Mouse_Status := Regs.bx;
  END;

END.
(* ------------------------------------------------------ *)
(*              Ende von HGCMOUSE.PAS                     *)
