(*-------------------------------------------------------*)
(*        Beispielprogramm zum Modula-Kurs, Teil 4       *)
(*           (C) 1989 Peter Viczena & toolbox            *)
(*-------------------------------------------------------*)

MODULE ArrayTst;

FROM    InOut   IMPORT  WriteString, WriteLn,
                        ReadInt, WriteInt;

CONST   Anzahl          = 4;      (* Einzulesende Zahlen *)

TYPE    Nummern         = INTEGER;
        Menge           = [0..Anzahl];
                                     (* Unterbereichstyp *)

        TelefonListe    = ARRAY Menge OF Nummern;

VAR     TestArray       : TelefonListe;
        Zahl            : Nummern;
        l               : CARDINAL;


PROCEDURE BubbleSort( VAR a : TelefonListe);
                                (* sortiert TelefonListe *)

VAR     i, j, k        : CARDINAL;

BEGIN
  FOR i := 1 TO Anzahl DO       (* Fr alle Zahlen, gehe *)
    FOR j := Anzahl TO i BY -1 DO
                              (* die nachfolgenden durch *)
      IF a[j-1] > a[j] THEN
        k      := a[j-1];   (* schau nach, ob sie grer *)
        a[j-1] := a[j];   (* sind. Wenn ja, dann tausche *)
        a[j]   := k;
      END;                                         (* IF *)

    END;                                          (* FOR *)
  END;                                            (* FOR *)
END BubbleSort;


BEGIN
  WriteString( 'Array-Test OF INTEGER'); WriteLn;
  WriteString( '---------------------'); WriteLn;
  WriteLn;
  WriteString( 'Bitte 5 Integer-Zahlen eingeben :');
  WriteLn;
  WriteLn;

  FOR l := 0 TO Anzahl DO
    WriteString( 'Zahl :');          (* Lies die Array-  *)
    ReadInt( Zahl);                  (*  Komponenten ein *)
    WriteLn;
    TestArray[l] := Zahl;
  END;                                            (* FOR *)

  BubbleSort( TestArray);                    (* sortiere *)

  WriteString( 'Zahlen sortiert:'); WriteLn;
  WriteLn;

  FOR l := 0 TO Anzahl DO           (* gib den Array aus *)
    WriteInt( TestArray[l], 5);
    WriteLn;
  END;                                            (* FOR *)

END ArrayTst.
(*-------------------------------------------------------*)
(*            Ende des Beispielprogramms                 *)
