(* ------------------------------------------------------ *)
(*                    BOOTMARK.PAS                        *)
(*        (c) 1989  Peter H.Danek  &  TOOLBOX             *)
(* ------------------------------------------------------ *)
PROGRAM Bootmark;

{$D-,I-,L-,R-,S-}
{$M $1000,0,0}

USES Crt, Dos;

CONST
  PassWd = 'MOUSE';

TYPE
  Datum = RECORD
            y, m, d, dow : WORD;
          END;
  Zeit  = RECORD
            h, m, s, s1  : WORD;
          END;
VAR
  dat : Datum;
  zt  : Zeit;
  t   : TEXT;
  s   : PathStr;
  ok  : BOOLEAN;

BEGIN
  ClrScr;
  CheckBreak := FALSE;
  Assign(t, 'C:\USERDATA');
  Reset(t);
  IF IOResult <> 0 THEN Rewrite(t);
  REPEAT
    Write('C:\>');  ReadLn(s);
    ok := (s = PassWd);
    Append(t);
    WITH dat DO BEGIN
      GetDate(y, m, d, dow);
      Write(t, 'Gestartet am ', d:2, '.', m:2, '.',y);
    END;
    WITH zt DO BEGIN
      GetTime(h, m, s, s1);
      WriteLn(t, ' um ', h:2, ':', m:2, ':', s:2);
    END;
    WriteLn(t, '  ',s);
    Close(t);
    IF NOT ok THEN BEGIN
      WriteLn('Falscher Befehl oder Dateiname');
      WriteLn;
    END;
  UNTIL ok;
  WriteLn('Logon erfolgreich...');
  WriteLn;
  CheckBreak := TRUE;
END.
(* ------------------------------------------------------ *)
(*              Ende von BOOTMARK.PAS                     *)
